function slide=nikkei
% NIKKEI
%   
% Jacques LEVY-VEHEL, Pierrick LEGRAND
% Copyright 2002   
% Date: 2002/04/29  $

if nargout<1,
  playshow nikkei
else
  %========== Slide 1 ==========
slide(1).code={'load nikkei225.txt;'
    'plot(nikkei225)'};
  
slide(1).text={
['The stock market is a fascinating area for fractal analysis.  Models based on stochastic processes ', ...
 'exhibiting long dependence and/or infinite variance have been shown to be relevant in ', ...
 'this area. In addition, stock market logs are ', ...
 'very irregular. This irregularity is a function of time, and ', ...
 'we expect that, for instance, at "quiet" periods, the market should ', ...
 'evolve smoothly, while krachs translate into sudden changes in the ', ...
 'regularity.'];
['A nice illustration of this is provided ', ...
    'by the analysis of the Nikkei225 index during the ' , ...
    'period 01/01/80 to 05/11/2000. The log consists in ' , ...
    '5313 daily values corresponding to that period.']};

%========== Slide 2 ==========

% slide(2).code={
%     'load nikkei225.txt;'
%     'plot(nikkei225)'};
% 
% 
% slide(2).text={
%   
%    ['A nice illustration of this is provided ', ...
%     'by the analysis of the Nikkei225 index during the ' , ...
%     'period 01/01/80 to 05/11/2000. The log consists in ' , ...
%     '5313 daily values corresponding to that period.']};

%========== Slide 3 ==========

slide(2).code={
   'lnikkei=log(nikkei225);'
   'plot(lnikkei)'
   '' };

slide(2).text={
   ['Financial analysts do not work directly on the prices, ',...
    'but on their logarithms, ', ...
    'so we first type'];
['>> lnikkei = log ( fnikkei225 ).']};
%    ''};

  %========== Slide 4 ==========

slide(3).code={
   'load demo_phtL_lnikkei0;'
   'plot(phtL_lnikkei0);'
   'AXIS([0 6000 0 7]);' };

slide(3).text={
   ['We now display an estimate of the local regularity of lnikkei: ',... 
  'More precisely, the plot above is the local Hlder exponent computed ', ...
 'as explained in ???help aidegen6.1???', ...
  'As one can see, most values of the local Hlder exponent are between 0 and 1, ', ...
 'with a few peaks above 1 and up to more than 6. Recall that a Hlder ', ...
 'exponent between 0 and 1 means that the signal is continuous but not ', ...
 'differentiable at the considered point. In addition, the lower the ', ...
 'exponent, the more irregular the signal. Looking at the original ', ...
 'signal, it appears obvious that the log is almost nowhere smooth, ', ...
 'which is consistent with the values of pht_lnikkei0. ' ]};

slide(4).code={
   'plot(2*lnikkei-15);hold on;'
   'plot(phtL_lnikkei0,''k'');'
   'plot(2036,linspace(1,8,1000)-1,''r'');'
   'plot(4450,linspace(1,8,1000)-1,''y'');'
   'plot(4800,linspace(1,8,1000)-1,''y'');'
   'AXIS([0 6000 0 7]);hold off;' };

slide(4).text={
   ['What is more ', ...
 'interesting is that important events in the log have a specific ', ...
 'signature in pht_lnikkei0: periods where "things happen" are ', ...
 'characterized by sudden increase in regularity, which passes above 1, ', ...
 'followed by very small values, e.g. below 0.2, which correspond to low ', ...
 'regularity. Two examples of this are the famous October 19 1987 krach (red)', ...
  'and the so-called Asian crisis (between the two yellow lines). ' ]};

slide(5).code={
   'plot(2*lnikkei-19);hold on;'
   'plot(phtL_lnikkei0,''k'');'
   'plot(2036,phtL_lnikkei0(2036),''r*'');'
   'plot(2036,linspace(1,7,1000)-1,''r'');'
   'AXIS([2000 2150 0 2]);hold off;' };

slide(5).text={
  ['The most prominent feature', ...
 ' is the peak at abscissa 2018. ', ...
 'Note also that the points with the lowest values in regularity of ', ...
 'the whole log are located just after this peak: The exponent is ', ...
 'around 0.2 at abscissa roughly between 2020 and 2050, and 0.05 at ', ...
 'abscissa between 2075 and 2100. Both values are well below the mean', ...
 'of 0.4 (the variance is 0.036). ', ...
 'The krach corresponds to ', ...
 'abscissa 2036, in the middle on the first low regularity period ', ...
 'after the peak. The days with smallest regularity are ', ...
 'located in the weeks following the krach, and one can ', ...
 'assess precisely which days were more erratic. These features are not ', ...
 'as easily seen on the original signal: Although the ', ...
 'krach is easily seen as a downward discontinuity at abscissa 2036, the ', ...
 'area around this point does not appear to be "special". ']};

  %========== Slide 5 ==========

% slide(6).code={
%    '%subplot(3,2,1);'
%    'plot(phtL_lnikkei0);hold on;'
%    '%AXIS([2020 2050 0 0.3])' 
%    '%subplot(3,2,3);'
%    '%plot(phtL_lnikkei0);'
%    '%AXIS([2075 2100 0 0.3])'
%    'AXIS([2000 2150 0 1]);'
%    'plot(2036,phtL_lnikkei0(2036),''r*'');'
%    'hold off;'};
% slide(6).text={
%    ['The most prominent feature of ', ...
%  'pht_lnikkei0 is the peak at abscissa 2018 with amplitude larger than ', ...
%  '6. Note also that the points with the lowest values in regularity of ', ...
%  'the whole log are located just after this peak: The Hlder exponent is ', ...
%  'around 0.2 at abscissa roughly between 2020 and 2050, and 0.05 at ', ...
%  'abscissa between 2075 and 2100.',...
%  'Both values are well below the mean of ', ...
%  'pht_lnikkei0, which is 0.4 (its variance of is 0.036). ', ...
%  'fact, only 10 percent of the points of the signal have an exponent ', ...
%  'smaller than 0.2.  Now the famous October 19 1987 krach corresponds to ', ...
%  'abscissa 2036, right in the middle on the first low regularity period ', ...
%  'after the peak. The days with smallest regularity in the whole log are ', ...
%  'logically located in the weeks following the krach, and one can ', ...
%  'assess precisely which days were more erratic. However, if you go back ', ...
%  'to original fnikkei225 signal, things are not so clear: although the ', ...
%  'krach is easily seen as a downward discontinuity at abscissa 2036, the ', ...
%  'area around this point does not appear to be more "special" than, for ', ...
%  'instance, the last part of the log (you may zoom on the different ', ...
%  'areas for easier visualization). ']};
% %========== Slide 6 ==========

slide(6).code={
   'plot(lnikkei-9);hold on;'
   'plot(phtL_lnikkei0,''k'');'
   'AXIS([4450 4800 0 1.5]);hold off;' };

slide(6).text={
   ['Another region contains many points with low Hlder ', ...
 'exponents with a few isolated very regular points. The area between abscissa 4450 and 4800 ', ...
 'corresponds to the "Asian crisis" period ', ...
 '(between January 1997 and June 1998). ',...
 'On the graph of the original log of the Nikkei225 ', ...
 'this period is quite erratic. Looking now at pht_lnikkei0, we ', ...
 'notice that there are two peaks with exponents larger than one in the ', ...
 'considered period. The first peak is around 4455, and is ', ...
 'followed by irregular points between 4465 and 4475. The second is ', ...
 'around 4730. This region has a large ', ...
 'proportion of irregular points: 12 % of its points have exponent ', ...
 'smaller than 0.15. This is three times the proportion observed in the ', ...
 'whole log. In addition, this area is the one with highest density of ', ...
 'points with exponent smaller than 0.15.']};

%========== Slide 7 ==========


   


end
