function fig = gui_fl_d2ml2spectrum()

% MAIN WINDOW
a = figure('Color',[0.8 0.8 0.8], ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Position',[165 50 360 500], ...
	'Units','pixels', ...
	'UserData',struct('Function',0,'Precision_frontier',10,'Frontier',0,'Choice_example',0,'Choice_waitbar',1,'Plot_Pointwise_exp',1,'Plot_Local_exp',1), ...
	'Tag','gui_fl_d2ml2spectrum_control_panel');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% TITLE FRAME    
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.252631578947368, ...
	'ListboxTop',0, ...
	'Position',[0.02 0.895 0.96 0.095], ...
	'Style','frame', ...
	'Tag','Frame_title');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.94 0.8 0.035], ...
	'String','Oscillation based 2-Micro-local Frontier', ...
	'Style','text', ...
	'Tag','StaticText_Title');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.90 0.8 0.035], ...
	'String','Estimation of an Interval (Method 2)', ...
	'Style','text', ...
	'Tag','StaticText_Title');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% INPUT FRAME
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.4, ...
	'Position',[0.02 0.825 0.96 0.06], ...
	'Style','frame', ...
	'Tag','Frame_input');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.835 0.25 0.035], ...
	'String','Input Signal', ...
	'Style','text', ...
	'Tag','StaticText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.685714285714286, ...
	'HorizontalAlignment','center', ...
	'Position',[0.32 0.84 0.4 0.035], ...
	'String','', ...
	'Style','edit', ...
	'Enable','inactive', ...
	'Tag','EditText_input');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''refresh_input'');', ...
	'FontSize',0.533333333333333, ...
	'FontWeight','bold', ...
	'Position',[0.75 0.835 0.175 0.045], ...
	'String','Refresh', ...
	'Tag','Pushbutton_refreshInput');
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.0979591836734694, ...
	'Position',[0.02 0.565 0.96 0.245], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.760 0.8 0.035], ...
	'String','2-microlocal frontier Estimation', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');




%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.695 0.60 0.04], ...
	'String','Discretization of the frontier', ...
	'Style','text', ...
	'Tag','StaticText_estim');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''precision_exp'');', ...
	'FontSize',0.48, ...
	'ListboxTop',0, ...
	'Max',5, ...
	'Min',1, ...
	'Position',[0.625   0.691    0.20    0.05], ...
	'String',{'10','15','20','25','30'}, ...
	'Style','popupmenu', ...
	'Tag','precision_exp', ...
	'Value',1);
%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.637 0.55 0.04], ...
	'String','Starting point of the analysis', ...
	'Style','text', ...
	'Tag','StaticText_point');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.55 0.637 0.15 0.04], ...
	'String','X', ...
	'Style','text', ...
	'Tag','StaticText_point');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.60 0.643 0.11 0.04], ...
	'String','1', ...
	'Style', 'edit', ...
	'Tag','starting_point_x');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.72 0.637 0.15 0.04], ...
	'String','Y', ...
	'Style','text', ...
	'Tag','StaticText_point');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.77 0.643 0.11 0.04], ...
	'String','1', ...
	'Style', 'edit', ...
	'Tag','starting_point_y');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.579 0.55 0.04], ...
	'String','Ending point of the analysis', ...
	'Style','text', ...
	'Tag','StaticText_point');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.55 0.579 0.15 0.04], ...
	'String','X', ...
	'Style','text', ...
	'Tag','StaticText_point');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.60 0.585 0.11 0.04], ...
	'String','2', ...
	'Style', 'edit', ...
	'Tag','ending_point_x');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.72 0.579 0.15 0.04], ...
	'String','Y', ...
	'Style','text', ...
	'Tag','StaticText_point');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'FontSize',0.6, ...
	'HorizontalAlignment','center', ...
	'Position',[0.77 0.585 0.11 0.04], ...
	'String','2', ...
	'Style', 'edit', ...
	'Tag','ending_point_y');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Results

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.48, ...
	'Position',[0.02 0.505 0.96 0.050], ...
	'Style','frame', ...
	'Tag','Frame_Results');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.508 0.8 0.035], ...
	'String','Results', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graphs of the 2-microlocal frontier FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.188976377952756, ...
	'Position',[0.02 0.369 0.96 0.127], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.1 0.441 0.8 0.035], ...
	'String','Graphs to be plotted', ...
	'Style','text', ...
	'Tag','StaticText_ml2fontier');
%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.385 0.4 0.04], ...
	'String','Example of estimation', ...
	'Style','text', ...
	'Tag','StaticText_example');


b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''choice_example'');', ...
	'FontSize',0.48, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625  0.385   0.20    0.05], ...
	'String',{'No','Yes'}, ...
	'Style','popupmenu', ...
	'Tag','choice_examp', ...
	'Value',1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Exponents FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.126315789473684, ...
	'Position',[0.02 0.170 0.96 0.190], ...
	'Style','frame', ...
	'Tag','Frame_Frontier');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'HorizontalAlignment','center', ...
	'FontUnits','normalized', ...
	'FontWeight','bold', ...	
	'FontSize',0.685714285714286, ...
	'ListboxTop',0, ...
	'Position',[0.1 0.315 0.8 0.035], ...
	'String','Plotting the Regularity exponents', ...
	'Style','text', ...
	'Tag','StaticText_regularity');


%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.245 0.65 0.035], ...
	'String','Pointwise Holder exponent', ...
	'Style','text', ...
	'Tag','StaticText_pointwise');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''plot_pointwise'');', ...
	'FontSize',0.48, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625  0.245   0.20    0.05], ...
	'String',{'Yes','No'}, ...
	'Style','popupmenu', ...
	'Tag','pointwise_p', ...
	'Value',1);

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.685714285714286, ...
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.190 0.65 0.035], ...
	'String','Local Holder exponent', ...
	'Style','text', ...
	'Tag','StaticText_local');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''plot_local'');', ...
	'FontSize',0.48, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625  0.190   0.20    0.05], ...
	'String',{'Yes','No'}, ...
	'Style','popupmenu', ...
	'Tag','local_p', ...
	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Waitbar FRAME

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.282352941176471, ...
	'Position',[0.02 0.075 0.96 0.085], ...
	'Style','frame', ...
	'Tag','Frame_Waitbar');

%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'FontWeight','bold', ...	
	'HorizontalAlignment','left', ...
	'Position',[0.05 0.095 0.65 0.04], ...
	'String','Visualize the 2ml frontiers?', ...
	'Style','text', ...
	'Tag','StaticText_wait');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''waitbar_screen'');', ...
	'FontSize',0.48, ...
	'ListboxTop',0, ...
	'Max',2, ...
	'Min',1, ...
	'Position',[0.625 0.095 0.20  0.05], ...
	'String',{'Yes','No'}, ...
	'Style','popupmenu', ...
	'Tag','wait_screen', ...
	'Value',1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GENERAL BUTTONS



b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','eval([''global '' fl_d2ml2spectrum_compute(''compute'',who)]);', ...	
	'FontSize',0.48, ...
	'Enable','off',...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.03 0.01 0.24 0.05], ...
	'String','Compute', ...
	'Tag','compute');

   
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','helpwin aide_ml2spectrum;', ...
	'FontSize',0.48, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.38 0.01 0.24 0.05], ...
	'String','Help', ...
	'Tag','button_help');   

 
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'Callback','fl_d2ml2spectrum_compute(''close'');', ...
	'FontSize',0.48, ...
	'FontWeight','bold', ...
	'ListboxTop',0, ...
	'Position',[0.73 0.01 0.24 0.05], ...
	'String','Close', ...
	'Tag','button_close');

fl_window_init(a);

fl_d2ml2spectrum_compute('refresh_input');        
    
if nargout > 0, fig = a; end
