function gui_fl_riesz()
% Revision 1.2 O.Meunier, INRIA, Fractales, 28 March 2002

load gui_fl_riesz

a = figure( ...
	'Colormap',[], ...
	'HandleVisibility','callback', ...
	'MenuBar','none', ...
	'Name','Generalized Riesz Products', ...
	'Position',[20 50 400 500], ...
	'Tag','Fig_gui_fl_riesz', ...
	'UserData',ws);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TITRE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.184615384615385, ...
	'Position',[0.0833333 0.85 0.833333 0.13], ...
	'Style','frame', ...
	'Tag','Frame_gui_fl_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.48, ...
	'FontWeight','bold', ...
	'Position',[0.213333 0.9 0.56 0.05], ...
	'String','Generalized Riesz Products ', ...
	'Style','text', ...
	'Tag','StaticText_riesz_title1');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.48, ...
	'FontWeight','bold', ...
	'Position',[0.213333 0.86 0.56 0.05], ...
	'String','with random phases', ...
	'Style','text', ...
	'Tag','StaticText_riesz_title2');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% FUNCTION
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.104347826086957, ...
	'Position',[0.0833333 0.6 0.833333 0.23], ...
	'Style','frame', ...
	'Tag','Frame_input_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.342857142857143, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'Position',[0.09 0.74 0.82 0.07], ...
	'String','W(x) Function (Choose one from the examples box below)', ...
	'Style','text', ...
	'Tag','StaticText_input_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_riesz_compute(''edit_function'');', ...
	'FontSize',0.6, ...
    'Position',[0.09 0.73 0.82 0.04], ...
    'String',ws.func, ...
	'Style','edit', ...
	'Tag','EditText_riesz_function');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.4, ...
	'FontWeight','bold', ...
	'HorizontalAlignment','left', ...
	'Position',[0.09 0.66 0.4 0.06], ...
	'String','Examples', ...
	'Style','text', ...
	'Tag','StaticText_input_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_riesz_compute(''listbox_function'');', ...
	'FontSize',0.342857142857143, ...
    'Position',[0.09 0.62 0.82 0.07], ...
    'String',{'1 + 0.5.*sin(2.*pi.*x)', '1 + 0.5.*sin(2.*pi.*x) + 0.1.*sin(4.*pi.*x)','2.*x', '(112/35).*sin(2.*pi.*x).^6'}, ...
    'Value',1,...
	'Style','listbox', ...
	'Tag','Listbox_riesz_function');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% PARAM
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.08, ...
	'Position',[0.0833333 0.285 0.833333 0.30], ...
	'Style','frame', ...
   'Tag','Frame_gui_fl_param');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% DEPTH
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Position',[0.1 0.50 0.2 0.04], ...
   	'HorizontalAlignment','left', ...
	'String','Depth', ...
	'Style','text', ...
   'Tag','StaticText_riesz_res');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Callback','fl_riesz_compute(''slider_depth'');', ...
	'Min',ws.N_min, ...
	'Max',ws.N_max, ...
	'Value',ws.N, ...
	'Position',[0.4 0.50 0.32 0.04], ...
	'Style','slider', ...
    'Tag','Slider_riesz_res');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_riesz_compute(''edit_depth'');', ...
    'Position',[0.78 0.50 0.12 0.04], ...
    'String',num2str(ws.N), ...
	'Style','edit', ...
	'Tag','EditText_riesz_res');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% BASE
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Position',[0.1 0.44 0.2 0.04], ...
   	'HorizontalAlignment','left', ...
	'String','Base', ...
	'Style','text', ...
   'Tag','StaticText_riesz_base');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Callback','fl_riesz_compute(''slider_base'');', ...
	'Min',ws.b_min, ...
	'Max',ws.b_max, ...
    'SliderStep', [1/(ws.b_max-ws.b_min) 5/(ws.b_max-ws.b_min)], ...
	'Value',ws.b, ...
	'Position',[0.4 0.44 0.32 0.04], ...
	'Style','slider', ...
	'Tag','Slider_riesz_base');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_riesz_compute(''edit_base'');', ...
    'Position',[0.78 0.44 0.12 0.04], ...
    'String',num2str(ws.b), ...
	'Style','edit', ...
   'Tag','EditText_riesz_base');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% RESOLUTION FINALE
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Position',[0.1 0.38 0.2 0.04], ...
   	'HorizontalAlignment','left', ...
	'String','Resolution', ...
	'Style','text', ...
   'Tag','StaticText_riesz_rf');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'BackgroundColor',[0.9 0.9 0.9], ...
	'Callback','fl_riesz_compute(''edit_base'');', ...
    'Position',[0.78 0.38 0.12 0.04], ...
    'String',num2str(ws.b*ws.N), ...
	'Style','edit', ...
    'Enable', 'inactive', ...
   'Tag','EditText_riesz_rf');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% ORDER
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Position',[0.1 0.32 0.2 0.04], ...
   	'HorizontalAlignment','left', ...
	'String','Product order', ...
	'Style','text', ...
   'Tag','StaticText_riesz_order');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Callback','fl_riesz_compute(''slider_order'');', ...
	'Min',ws.K_min, ...
	'Max',ws.K_max, ...
	'Value',ws.K, ...
	'Position',[0.4 0.32 0.32 0.04], ...
	'Style','slider', ...
    'Tag','Slider_riesz_order');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'BackgroundColor',[1 1 1], ...
	'Callback','fl_riesz_compute(''edit_order'');', ...
	'Position',[0.78 0.32 0.12 0.04], ...
    'String',num2str(ws.K), ...
	'Style','edit', ...
    'Tag','EditText_riesz_order');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%PHASE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.3, ...
	'Position',[0.0833333 0.19 0.833333 0.08], ...
	'Style','frame', ...
	'Tag','Frame_gui_fl_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Callback','', ...
	'FontWeight','bold', ...
	'Position',[0.1 0.21 0.50 0.04], ...
	'String','Keep previous phases', ...
    'Style','checkbox', ...
    'Value',0, ...
	'Tag','Checkbox_riesz_keep_phase');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'FontWeight','bold', ...
	'Position',[0.6 0.21 0.25 0.04], ...
	'String','No phases', ...
    'Style','checkbox', ...
    'Value',0, ...
	'Tag','Checkbox_riesz_no_phase');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% SPECTRUM
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.3, ...
	'Position',[0.0833333 0.1 0.833333 0.08], ...
	'Style','frame', ...
	'Tag','Frame_gui_fl_riesz');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'Callback','fl_riesz_compute(''check_spectrum'');', ...
	'FontWeight','bold', ...
	'Position',[0.1 0.12 0.50 0.04], ...
	'String','Compute Multifractal Spectrum', ...
    'Style','checkbox', ...
    'Value',0, ...
	'Tag','Checkbox_riesz_spectrum');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TAU(Q)
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.6, ...
	'FontWeight','bold', ...
	'Position',[0.6 0.12 0.25 0.04], ...
	'String','Output tau(q)', ...
    'Style','checkbox', ...
    'Value',0, ...
    'Enable', 'off', ...
	'Tag','Checkbox_riesz_tauq');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% BUTTONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.4, ...
	'Callback','eval([''global '' fl_riesz_compute(''compute'',who)])', ...
	'FontWeight','bold', ...
	'Position',[0.0833333 0.02 0.233333 0.06], ...
	'String','Compute', ...
	'Tag','Pushbutton_riesz_compute');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.4, ...
	'Callback','fl_riesz_compute(''help'');', ...
	'FontWeight','bold', ...
	'Position',[0.38 0.02 0.233333 0.06], ...
	'String','Help', ...
	'Tag','Pushbutton_riesz_help');
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'FontUnits','normalized', ...
	'FontSize',0.4, ...
	'Callback','fl_riesz_compute(''close'');', ...
	'FontWeight','bold', ...
	'Position',[0.676667 0.02 0.233333 0.06], ...
	'String','Close', ...
	'Tag','Pushbutton_close');

fl_window_init(a);